<form [formGroup]="form">
  <solidify-detail-presentation [centerTemplate]="centerTemplate"
                                [iconName]="iconNameEnum.aip"
                                [rightTemplate]="rightTemplate"
  ></solidify-detail-presentation>

  <ng-template #centerTemplate>

    <div *ngIf="readonly"
         class="header"
    >
      <solidify-status *ngIf="getFormControl(formDefinition.status) as fd"
                       [statusModel]="enumUtil.getKeyValue(packageStatusEnumValuesTranslate, fd.value)"
      ></solidify-status>
    </div>

    <solidify-searchable-single-select *ngIf="getFormControl(formDefinition.organizationalUnitId) as fd"
                                       [formControl]="fd"
                                       [labelKey]="'name'"
                                       [placeholder]="labelTranslateEnum.organizationalUnit | translate"
                                       [readonly]="true"
                                       [required]="formValidationHelper.hasRequiredField(fd)"
                                       [resourceNameSpace]="appAuthorizedOrganizationalUnitNameSpace"
                                       [state]="appAuthorizedOrganizationalUnitState"
                                       [valueKey]="'resId'"
    >
    </solidify-searchable-single-select>

    <mat-form-field *ngIf="getFormControl(formDefinition.id) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.resId | translate}}</mat-label>
      <input [formControl]="fd"
             matInput
      >
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.name) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.nameLabel | translate}}</mat-label>
      <input [formControl]="fd"
             matInput
      >
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.description) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.description | translate}}</mat-label>
      <textarea [formControl]="fd"
                cdkAutosizeMaxRows="7"
                cdkAutosizeMinRows="5"
                cdkTextareaAutosize
                matInput
      >
        </textarea>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.lastchecksumCheck) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.lastChecksumVerification | translate}}</mat-label>
      <input [formControl]="fd"
             matInput
      >
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.archive) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.archive | translate}}</mat-label>
      <input [formControl]="fd"
             matInput
      >
    </mat-form-field>

    <div class="span-row">
      <mat-form-field *ngIf="getFormControl(formDefinition.archiveFileNumber) as fd"
                      [appearance]="appearanceInputMaterial"
                      [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                      solidifyTooltipOnEllipsis
      >
        <mat-label>{{labelTranslateEnum.numberOfFiles | translate}}</mat-label>
        <input [formControl]="fd"
               matInput
        >
      </mat-form-field>

      <ng-container *ngIf="getFormControl(formDefinition.collectionFileNumber) as fd">
        <mat-form-field  *ngIf="isAipCollection()"
                        [appearance]="appearanceInputMaterial"
                        [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                        solidifyTooltipOnEllipsis
        >
          <mat-label>{{labelTranslateEnum.collectionFilesNumber | translate}}</mat-label>
          <input [formControl]="fd"
                 matInput
          >
        </mat-form-field>
      </ng-container>
    </div>

    <div [class.only-one]="getFormControl(formDefinition.status).value !== packageStatusEnum.DISPOSED"
         class="span-row"
    >

      <mat-form-field *ngIf="getFormControl(formDefinition.smartSize) as fd"
                      [appearance]="appearanceInputMaterial"
                      [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                      solidifyTooltipOnEllipsis
      >
        <mat-label>{{labelTranslateEnum.archiveSize | translate}}</mat-label>
        <input [formControl]="fd"
               matInput
        >
      </mat-form-field>

      <ng-container *ngIf="getFormControl(formDefinition.collectionSmartSize) as fd">
        <mat-form-field *ngIf="isAipCollection()"
                        [appearance]="appearanceInputMaterial"
                        [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                        solidifyTooltipOnEllipsis
        >
          <mat-label>{{labelTranslateEnum.collectionSize | translate}}</mat-label>
          <input [formControl]="fd"
                 matInput
          >
        </mat-form-field>
      </ng-container>

      <ng-container *ngIf="getFormControl(formDefinition.status) as fd">
        <mat-form-field *ngIf="fd.value === packageStatusEnum.DISPOSED"
                        [appearance]="appearanceInputMaterial"
                        [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                        solidifyTooltipOnEllipsis
        >
          <mat-label>{{labelTranslateEnum.metadataSize | translate}}</mat-label>
          <input [formControl]="fd"
                 matInput
          >
        </mat-form-field>
      </ng-container>
    </div>

    <div class="span-row">
      <mat-form-field *ngIf="getFormControl(formDefinition.retention) as fd"
                      [appearance]="appearanceInputMaterial"
                      [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                      solidifyTooltipOnEllipsis
      >
        <mat-label>{{labelTranslateEnum.retentionDuration | translate}}</mat-label>
        <input [formControl]="fd"
               matInput
        >
      </mat-form-field>
      <mat-form-field *ngIf="getFormControl(formDefinition.retentionEnd) as fd"
                      [appearance]="appearanceInputMaterial"
                      [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                      solidifyTooltipOnEllipsis
      >
        <mat-label>{{labelTranslateEnum.retentionExpiration | translate}}</mat-label>
        <input [formControl]="fd"
               matInput
        >
      </mat-form-field>
    </div>

  </ng-template>

  <ng-template #rightTemplate>
    <div class="year-wrapper">
      <solidify-icon [iconName]="iconNameEnum.creationDate"
                     class="icon"
      ></solidify-icon>
      <mat-form-field [appearance]="appearanceInputMaterial"
                      solidifyTooltipOnEllipsis
      >
        <mat-label>{{labelTranslateEnum.year | translate}}</mat-label>
        <input [formControlName]="formDefinition.yearOfCreation"
               matInput
        >
      </mat-form-field>
    </div>

    <div class="access-level-wrapper">
      <dlcm-shared-access-level [accessLevel]="getFormControl(formDefinition.access)?.value"
                                class="icon"
      ></dlcm-shared-access-level>
      <mat-form-field *ngIf="getFormControl(formDefinition.access) as fd"
                      [appearance]="appearanceInputMaterial"
                      [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                      solidifyTooltipOnEllipsis
      >
        <mat-label>{{labelTranslateEnum.accessLevel | translate}}</mat-label>
        <mat-select [formControl]="fd"
        >
          <mat-option *ngFor="let accessLevel of accessEnumValues"
                      [value]="accessLevel.key"
                      solidifyTooltipOnEllipsis
          >
            {{accessLevel.value | translate}}
          </mat-option>
        </mat-select>
      </mat-form-field>
    </div>

    <dlcm-shared-data-sensitivity-input [formControl]="getFormControl(formDefinition.dataSensitivity)"></dlcm-shared-data-sensitivity-input>

    <solidify-panel-expandable *ngIf="getFormControl(formDefinition.embargoAccess)?.value | isNotNullNorUndefined"
                               [isOpen]="true"
                               [titleToTranslate]="labelTranslateEnum.archiveEmbargo | translate"
                               class="section-embargo"
    >
      <ng-container *ngIf="getFormControl(formDefinition.embargoAccess) as fd">
        <div *ngIf="fd?.value"
             class="access-level-embargo-wrapper"
        >
          <dlcm-shared-access-level [accessLevel]="fd?.value"
                                    class="icon"
          ></dlcm-shared-access-level>
          <mat-form-field [appearance]="appearanceInputMaterial"
                          [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                          solidifyTooltipOnEllipsis
          >
            <mat-label>{{labelTranslateEnum.embargoAccessLevel | translate}}</mat-label>
            <mat-select [value]="fd?.value"
                        disabled
            >
              <mat-option *ngFor="let accessLevel of accessEnumValues"
                          [value]="accessLevel.key"
                          solidifyTooltipOnEllipsis
              >
                {{accessLevel.value | translate}}
              </mat-option>
            </mat-select>
          </mat-form-field>
        </div>
      </ng-container>

      <ng-container *ngIf="getFormControl(formDefinition.embargoNumberMonths) as fd">
        <mat-form-field *ngIf="fd.value"
                        [appearance]="appearanceInputMaterial"
                        [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                        solidifyTooltipOnEllipsis
        >
          <mat-label>{{labelTranslateEnum.embargoDuration | translate}}</mat-label>
          <input [value]="fd.value"
                 disabled
                 matInput
          >
        </mat-form-field>
      </ng-container>

      <ng-container *ngIf="getFormControl(formDefinition.embargoStartDate) as fd">
        <mat-form-field *ngIf="fd.value"
                        [appearance]="appearanceInputMaterial"
                        [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                        solidifyTooltipOnEllipsis
        >
          <mat-label>{{labelTranslateEnum.embargoStartDate | translate}}</mat-label>
          <input [value]="fd.value"
                 disabled
                 matInput
          >
        </mat-form-field>
      </ng-container>
    </solidify-panel-expandable>

    <solidify-searchable-single-select *ngIf="getFormControl(formDefinition.licenseId) as fd"
                                       [formControl]="fd"
                                       [labelKey]="'title'"
                                       [placeholder]="labelTranslateEnum.license | translate"
                                       [readonly]="readonly"
                                       [required]="formValidationHelper.hasRequiredField(fd)"
                                       [resourceNameSpace]="sharedLicenseActionNameSpace"
                                       [state]="sharedLicenseState"
                                       [valueKey]="'resId'"
    >
    </solidify-searchable-single-select>

    <dlcm-shared-compliance-level-rating [formControl]="getFormControl(formDefinition.complianceLevel)"></dlcm-shared-compliance-level-rating>

    <mat-form-field *ngIf="getFormControl(formDefinition.metadataVersion) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.metadataVersion | translate}}</mat-label>
      <input [formControl]="fd"
             matInput
      >
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.container) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.container | translate}}</mat-label>
      <input [formControl]="fd"
             matInput
      >
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.lastArchiving) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    [matTooltip]="labelTranslateEnum.lastArchivingTooltip | translate"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.lastArchiving | translate}}</mat-label>
      <input [formControl]="fd"
             matInput
      >
    </mat-form-field>

    <mat-checkbox *ngIf="getFormControl(formDefinition.contentStructurePublic) as fd"
                  [formControl]="fd"
                  [matTooltipPosition]="'left'"
                  [matTooltipShowDelay]="TIME_BEFORE_DISPLAY_TOOLTIP"
                  [matTooltip]="labelTranslateEnum.tooltipContentStructurePublic | translate"
                  aria-label="tooltip"
                  class="is-structure"
                  color="primary"
    >{{labelTranslateEnum.contentStructurePublic | translate}}
    </mat-checkbox>

    <dlcm-shared-package-button-navigator *ngIf="mode !== aipMode.AIP_STEWARD && !(model.sipIds | isNullOrUndefined) && (model.sipIds | isNonEmptyArray)"
                                          [currentViewMode]="currentPackageButtonNavigatorType"
                                          [sipId]="model?.sipIds?.length > 0 ? model.sipIds[0] : undefined"
                                          [aipId]="model?.resId"
                                          [currentStorageIndex]="currentStorageIndex"
    >
    </dlcm-shared-package-button-navigator>
  </ng-template>

  <dlcm-shared-additional-information-panel-container *ngIf="model | isNotNullNorUndefined"
                                                      [resource]="model"
  >
  </dlcm-shared-additional-information-panel-container>
</form>
